"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ShortTandemRepeat(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "coordinates",
        "reportEvents",
        "variantCalls",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "coordinates": reports_6_8_0.Coordinates,
            "reportEvents": reports_6_8_0.ReportEvent,
            "shortTandemRepeatReferenceData": reports_6_8_0.ShortTandemRepeatReferenceData,
            "variantAttributes": reports_6_8_0.VariantAttributes,
            "variantCalls": reports_6_8_0.VariantCall,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.Coordinates": reports_6_8_0.Coordinates,
            "org.gel.models.report.avro.ReportEvent": reports_6_8_0.ReportEvent,
            "org.gel.models.report.avro.ShortTandemRepeatReferenceData": reports_6_8_0.ShortTandemRepeatReferenceData,
            "org.gel.models.report.avro.VariantAttributes": reports_6_8_0.VariantAttributes,
            "org.gel.models.report.avro.VariantCall": reports_6_8_0.VariantCall,
            "org.gel.models.report.avro.ShortTandemRepeat": reports_6_8_0.ShortTandemRepeat,
        }

    __slots__ = [
        "coordinates",
        "reportEvents",
        "variantCalls",
        "shortTandemRepeatReferenceData",
        "variantAttributes",
    ]

    def __init__(
        self,
        coordinates,
        reportEvents,
        variantCalls,
        shortTandemRepeatReferenceData=None,
        variantAttributes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.ShortTandemRepeat model.

        :param coordinates:
        :type coordinates: Coordinates
        :param reportEvents:
        :type reportEvents: list[ReportEvent]
        :param variantCalls:
            array of genotypes for the samples
        :type variantCalls: list[VariantCall]
        :param shortTandemRepeatReferenceData:
        :type shortTandemRepeatReferenceData: None | ShortTandemRepeatReferenceData
        :param variantAttributes:
        :type variantAttributes: None | VariantAttributes
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
